/*
 * AuthWindow.java
 *
 * Created on 2010/05/15, 22:09:33
 */

package main;

import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import java.awt.Desktop;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.io.IOException;
import java.net.URI;

import twitter4j.*;

/**
 *
 * @author yayugu
 */
public class AuthWindow extends javax.swing.JDialog {
    Data data = Data.getInstance();

    /** Creates new form AuthWindow */
    public AuthWindow() {
        initComponents();
        ImageIcon imageIcon = new ImageIcon(getClass().getResource("/main/resources/icon16.png"));
        this.setIconImage(imageIcon.getImage());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        pin = new javax.swing.JTextField();
        getOAuthAccessToken = new javax.swing.JButton();
        getAuthorizationCode = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setText("認証");

        jLabel2.setText("コード:");

        getOAuthAccessToken.setText("認証");
        getOAuthAccessToken.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getOAuthAccessTokenActionPerformed(evt);
            }
        });

        getAuthorizationCode.setText("コード取得");
        getAuthorizationCode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getAuthorizationCodeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pin, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(getOAuthAccessToken)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(getAuthorizationCode)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(33, 33, 33)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(pin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(getOAuthAccessToken)
                    .addComponent(getAuthorizationCode))
                .addContainerGap(42, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void getAuthorizationCodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_getAuthorizationCodeActionPerformed
        data.instantiateTwitter();
        Desktop desktop = Desktop.getDesktop();
        
        URI uri = data.getAuthorizationURL();
        if (uri == null) {
        	JOptionPane.showMessageDialog(rootPane, "Failed to get the authorization URL",
        			"Authorization Error", JOptionPane.ERROR_MESSAGE);
        	return;
        }
        try {
			desktop.browse(uri);
		} catch (IOException e) {
			String str = uri.toString(); // 保存するテキスト
			Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
			StringSelection selection = new StringSelection(str);
			clipboard.setContents(selection, null);
        	JOptionPane.showMessageDialog(rootPane, 
        			"Failed to open a browser. Go to the following URL to get PIN code.\n" 
        			+ "This URL is set to the clipboard.\n"
        			+ uri.toString(),
        			"Authorization Error", JOptionPane.ERROR_MESSAGE);
		}
    }//GEN-LAST:event_getAuthorizationCodeActionPerformed

    private void getOAuthAccessTokenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_getOAuthAccessTokenActionPerformed
        try{
            if(pin.getText().length() > 0){
                data.accessToken = data.getTwitter().getOAuthAccessToken(data.requestToken, pin.getText());
            }else{
                data.accessToken = data.getTwitter().getOAuthAccessToken();
            }
            this.dispose();
        } catch (TwitterException te) {
            if(401 == te.getStatusCode()){
                JOptionPane.showMessageDialog(this, "Unable to get the access token.", "エラー", JOptionPane.ERROR_MESSAGE);
            }else{
                te.printStackTrace();
            }
        }
        data.saveData();

    }//GEN-LAST:event_getOAuthAccessTokenActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton getAuthorizationCode;
    private javax.swing.JButton getOAuthAccessToken;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField pin;
    // End of variables declaration//GEN-END:variables

}
